#ifndef RAWINPUTLSTM__H
#define RAWINPUTLSTM__H

#include <torch/torch.h>
#include "Submodule.hpp"
#include "LSTM.hpp"

class RawInputLSTMImpl : public torch::nn::Module, public Submodule
{
  private :

  LSTM lstm{nullptr};
  int leftWindow, rightWindow;

  public :

  RawInputLSTMImpl(int leftWindow, int rightWindow, int embeddingsSize, int outEmbeddingsSize, LSTMImpl::LSTMOptions options);
  torch::Tensor forward(torch::Tensor input);
  std::size_t getOutputSize() override;
  std::size_t getInputSize() override;
  void addToContext(std::vector<std::vector<long>> & context, Dict & dict, const Config & config, bool splitUnknown) const override;
};
TORCH_MODULE(RawInputLSTM);

#endif

